<?php
#-----------------------------------------------------------------------
# display source of script if requested so
#-----------------------------------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
        $filenameReal = __FILE__;
        $download_size = filesize($filenameReal);
        header('Pragma: public');
        header('Cache-Control: private');
        header('Cache-Control: no-cache, must-revalidate');
        header("Content-type: text/plain");
        header("Accept-Ranges: bytes");
        header("Content-Length: $download_size");
        header('Connection: close');
        readfile($filenameReal);
        exit;
}
if (isset ($_GET['debug'])) {
	ini_set('display_errors', 'On'); 
	error_reporting(E_ALL);	
}
$SITE			= array();
#
$pageName		= 'realtimeMB.php';
$pageVersion	        = '3.0b 2014-09-17';
$SITE['wsModules'][$pageName]   = 'version: ' . $pageVersion; 
$pageFile = basename(__FILE__);	
if ($pageFile <> $pageName) {
	$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName.' - '.$pageVersion;
}
$realtimeScript         = $pageName.' - '.$SITE['wsModules'][$pageFile];
# ------------------------------------------------------------------------------
# to load the changed data into string and send it back to the requesting ajax handler 
# first some inits
# ------------------------------------------------------------------------------
#
$SITE['WXsoftware']     = 'MB';
$folderdown		= '../';  // from how many folders up is this script called (normally from gauges/)
#
chdir ($folderdown);
include                 'wsSettings.php';
include                 'wsSettingsWeather.php';
#  for translating the forecast
$lang	                = $SITE['lang'];		// default language,
if (isset($_REQUEST['lang'])){				// than check this request settings
        $s              = trim(strtolower($_REQUEST['lang']));
        if (isset($SITE['installedLanguages'][$s]))	{ 
                $lang = $s; 
        }
}
# now save for further reference
$SITE['lang']		= $lang;
#
if ($SITE['userChangeUOM']) {
	$cookie = $SITE['cookieName']."uom";
	$temp='x';$baro='x';$wind='x';$rain='x';
	if (isset ($_COOKIE[$cookie])) {
		$uom =  trim($_COOKIE[$cookie]);
		list($temp, $baro, $wind, $rain) = explode ('|',$uom);		
	}
	if ($temp == 'c' ) 	{$SITE['uomTemp'] ='&deg;C';} 	
	elseif ($temp == 'f' ) 	{$SITE['uomTemp'] = '&deg;F';} 	else 	{$temp ='x';}
	if ($baro == 'hpa' ) 	{$SITE['uomBaro'] =' hPa';} 	
	elseif ($baro == 'mb' )	{$SITE['uomBaro'] = ' mb';} 	
	elseif($baro == 'inhg')	{$SITE['uomBaro'] = ' inHg';}   else {$baro='x';}
	if ($wind == 'kmh' )	{$SITE['uomWind'] =' km/h';} 	
	elseif ($wind == 'kts' ){$SITE['uomWind'] = ' kts';} 	
	elseif ($wind == 'ms')	{$SITE['uomWind'] = ' m/s';}  
	elseif ($wind == 'mph' ){$SITE['uomWind'] = ' mph';}    else {$wind='x';}
	if ($rain == 'mm' ) 	{$SITE['uomRain'] =' mm';} 		
	elseif ($rain == 'in' ) {$SITE['uomRain'] = ' in';} 	else 	{$rain='x';}
	}
#
# read file into string
if (isset ($SITE['steelFile'])) {
	$fileName = $SITE['steelFile'];
}  else {echo 'error - no input-file specified - program halted'; exit;}
#												strJson contents: {"date":"17:29","temp":"27,0","tempTL":"11,0",
$string 	= file_get_contents($fileName);
$pos            = strpos (substr($string,0,20),'|',0);
if (!$pos) {$split_char = ',';} else {$split_char = '|';}

$arrVars	= explode ($split_char,$string);
#
if (isset ($_GET['debug'])) {
	echo '<pre>';
	echo 'weather-program = '.$SITE['WXsoftware'].PHP_EOL;
	echo 'realtime script = '.$realtimeScript.PHP_EOL;
	echo 'input file = '.$fileName.PHP_EOL;
	echo 'input string = '.$string.PHP_EOL;
	echo 'processed to input array ='.PHP_EOL;
	var_dump ($arrVars);
}
#
include_once    $SITE['functions'];
include_once    $SITE['langFunc'];
#
$fromTemp	= 'C';
$fromWind	= 'm/s';
$fromRain	= 'mm';
$fromBaro	= 'hPa';
#
#	$arrVars[nr]
#       0       1		2		3		4       5		6		7		8		9
# [hh]:[mm],[th0temp-act],[th0temp-dmin],[th0temp-dmax],[thb0temp-act],[th0dew-act],[th0dew-dmin],[th0dew-dmax],[wind0chill-act],[wind0chill-dmin],
#	10		11			12		13		14		15		16		17			18		19
# [wind0wind-act],[wind0avgwind-act],[wind0wind-max10],[wind0wind-dmax],[wind0dir-act],[wind0dir-avg10:--],[thb0seapress-act],[thb0seapress-dmin],[thb0seapress-dmax],[thb0seapress-ymin],
#	20		21			22		23		24	   25		26		27		28		29
# [thb0seapress-ymax],[rain0total-daysum],[rain0rate-act],[rain0rate-dmax],[th0hum-act],[th0hum-dmin],[th0hum-dmax],[thb0hum-act],[th0temp-val60:--],[th0temp-dmintime],
#	30		31			32		33		34			35		36		37				38			39
# [th0temp-dmaxtime],[th0dew-dmintime],[th0dew-dmaxtime],[wind0chill-dmin],[rain0rate-dmaxtime],[th0hum-dmintime],[th0hum-dmaxtime],[thb0seapress-dmintime],[thb0seapress-dmaxtime],[thb0seapress-val60:--],
#		40		41			42		43		44		45		46			47		48				49
# [wind0wind-act=bft.0],[wind0wind-dmaxtime],[wind0avgwind-dmax],[uv0index-act:--],[sol0rad-act:--],[sol0rad-hmax:--],[sol0rad-dmax:--],[mbsystem-swversion],[mbsystem-buildnum],[YYYY]:[MM]:[DD]:[Uhh]:[Umm]:[Uss]
#       50
#[forecast-text]

$arrOut['date']		= $arrVars[0];														// "20130216180557"
#												 
$arrOut['temp']		= (string)wsConvertTemperature($arrVars[1], $fromTemp);	
$arrOut['tempTL']	= (string)wsConvertTemperature($arrVars[2], $fromTemp);	
$arrOut['tempTH']	= (string)wsConvertTemperature($arrVars[3], $fromTemp);	
$arrOut['intemp']	= (string)wsConvertTemperature($arrVars[4], $fromTemp);	
$arrOut['dew']		= (string)wsConvertTemperature($arrVars[5], $fromTemp);	
$arrOut['dewpointTL']	= (string)wsConvertTemperature($arrVars[6], $fromTemp);	
$arrOut['dewpointTH']	= (string)wsConvertTemperature($arrVars[7], $fromTemp);	
$arrOut['apptemp']	= "0";	
$arrOut['apptempTL']	= "0";	
$arrOut['apptempTH']	= "0";	
$arrOut['wchill']	= (string)wsConvertTemperature($arrVars[8], $fromTemp);	
$arrOut['wchillTL']	= (string)wsConvertTemperature($arrVars[9], $fromTemp);	

$arrOut['heatindex']	= "0"; // calculate from temp and hum
$arrOut['heatindexTH']	= "0";

$arrOut['humidex']	= "0";  // calculate from temp and hum

$arrOut['wlatest']	= (string)wsConvertWindspeed($arrVars[10], $fromWind);	
$arrOut['wspeed']	= (string)wsConvertWindspeed($arrVars[11], $fromWind);	
$arrOut['wgust']	= (string)wsConvertWindspeed($arrVars[12], $fromWind);	
$arrOut['wgustTM']	= (string)wsConvertWindspeed($arrVars[13], $fromWind);	

$arrOut['bearing']	= (string)$arrVars[14];	
$arrOut['avgbearing']	= (string)$arrVars[15];	
	
$arrOut['press']	= (string)wsConvertBaro($arrVars[16], $fromBaro);
$arrOut['pressTL']	= (string)wsConvertBaro($arrVars[17], $fromBaro);
$arrOut['pressTH']	= (string)wsConvertBaro($arrVars[18], $fromBaro);
$arrOut['pressL']	= (string)wsConvertBaro($arrVars[19], $fromBaro);
$arrOut['pressH']	= (string)wsConvertBaro($arrVars[20], $fromBaro);

$arrOut['rfall']	= (string)wsConvertRainfall($arrVars[21], $fromRain);	
$arrOut['rrate']	= (string)wsConvertRainfall($arrVars[22], $fromRain);	
$arrOut['rrateTM']	= (string)wsConvertRainfall($arrVars[23], $fromRain);	

$arrOut['hum']		= (string)$arrVars[24];	
$arrOut['humTL']	= (string)$arrVars[25];	
$arrOut['humTH']	= (string)$arrVars[26];	
$arrOut['inhum']	= (string)$arrVars[27];	

$arrOut['SensorContactLost']= "0";

$from 		= array ('hrs.', 'temp.',' windy');
$to   		= array ('hours', 'temperature', '.windy');
$value 		= str_replace ($from, $to,trim($arrVars[50]) );		// "Partly cloudy with little temperature change.",

$arrVantage	= explode('.',$value.'.');
$text		= '';
$end		= count($arrVantage);
for ($i=0;$i < $end; $i++){
	$strng	= trim($arrVantage[$i]);
	if ((isset($strng) && (strlen($strng) >= 1))) {
		$text.='&nbsp;&nbsp;'.langtransstr(ucfirst($strng));
		}
}
if (trim($text) <> '') {
        $arrOut['forecast']     = $text;
} else {
        $arrOut['forecast']	= langtransstr('Data will be reloaded in ');
}
$arrOut['tempunit']		= (string)str_replace('&deg;','',$SITE['uomTemp']);
$arrOut['windunit']		= (string)trim($SITE['uomWind']);				
$arrOut['pressunit']	        = (string)trim($SITE['uomBaro']);		
$arrOut['rainunit']		= (string)trim($SITE['uomRain']);	
$temphour = $arrVars[28];
if ($temphour <> '--') {
	$arrOut['temptrend']    = (string)($arrVars[1] - $temphour); 
} else {
	$arrOut['temptrend']    = "0";
}

$arrOut['TtempTL']		= wsMBtime($arrVars[29]);	
$arrOut['TtempTH']		= wsMBtime($arrVars[30]);	
$arrOut['TdewpointTL']	        = wsMBtime($arrVars[31]);	
$arrOut['TdewpointTH']	        = wsMBtime($arrVars[32]);	
$arrOut['TapptempTL']	        = '00:00';
$arrOut['TapptempTH']	        = '00:00';
$arrOut['TwchillTL']	        = wsMBtime($arrVars[33]);			
$arrOut['TheatindexTH']	        = '00:00';
$arrOut['TrrateTM']		= wsMBtime($arrVars[34]);
$arrOut['ThourlyrainTH']        = '00:00';

#$arrOut['LastRained']          = (string)$arrVars['LastRained'];	

$arrOut['hourlyrainTH']	        = "0"; 	

$arrOut['ThumTL']		= wsMBtime($arrVars[35]);	
$arrOut['ThumTH']		= wsMBtime($arrVars[36]);
$arrOut['TpressTL']		= wsMBtime($arrVars[37]);
$arrOut['TpressTH']		= wsMBtime($arrVars[38]);
$pressHour	                = $arrVars[39];
if ($pressHour <> '--') {
	$presstrendval		= $arrVars[16] - $pressHour;
	$arrOut['presstrendval']= (string)wsConvertBaro($presstrendval,$fromBaro);	
} else {
	$arrOut['presstrendval']= "0";
}

$arrOut['Tbeaufort']	        = (string)$arrVars[40];			
$arrOut['TwgustTM']		= wsMBtime($arrVars[41]);	

$arrOut['windTM']		= (string)wsConvertWindspeed($arrVars[42], $fromWind);		

#$arrOut['bearingTM']	        = (string)$arrVars['bearingTM'];		

$arrOut['timeUTC']		= str_replace(':',',',$arrVars[49]);	

$arrOut['BearingRangeFrom10']	= '0';	
$arrOut['BearingRangeTo10']	        = '359';	

$arrOut['UV']			= (string)$arrVars[43];	
$arrOut['SolarRad']		= (string)$arrVars[44];	
$arrOut['CurrentSolarMax']      = (string)$arrVars[45];	
$arrOut['SolarTM']		= (string)$arrVars[46];		
$arrOut['version']		= (string)$arrVars[47];		
$arrOut['build']		= (string)$arrVars[48];		
$arrOut['ver']			= '9';		
#
# these are skipped from the input
#$arrOut['domwinddir']	= (string)$arrVars['domwinddir'];	
#$arrOut['WindRoseData']	= $arrVars['WindRoseData'];	
#$arrOut['windrun']		= (string)wsConvertWindspeed($arrVars['windrun'], $fromWind);
#
# send converted info back
if ( isset($_GET['debug']) ) {
	echo '<br />'.PHP_EOL;
	echo 'processed to output array ='.PHP_EOL;
	var_dump ($arrOut);
	echo 'data returned to calling javaxcript program ='.PHP_EOL;
} 
if (function_exists('json_encode') ){
	$string = json_encode($arrOut);
} 
# No json support so we have to make our own json string.
$string = '{';
$seperator='';
foreach  ($arrOut as $key => $value) {
	$string.=$seperator;
	$string.= '"'.$key.'":"'.(string)$value.'"';
	$seperator= ',';
}
$string .= '}';
if (! isset($_GET['debug']) ) {header("Content-Type: text/plain; charset=UTF-8");}
echo $string;

function wsMBtime($value) {	// 20130216142235 ==> 14:22
	$return = substr(trim($value),8,2).':'.substr(trim($value),10,2);
	return $return;
}
?>